\version "2.19.22"
\language "english"
% adapted from http://lsr.di.unimi.it/LSR/Item?id=784

% Define the alterations as fraction of the equal-tempered whole tone.
#(define-public SEVEN-E-SHARP  7/8)
#(define-public SHARP-RAISE    5/8)
#(define-public SHARP-LOWER    3/8)
#(define-public NATURAL-RAISE  1/8)
#(define-public NATURAL-LOWER -1/8)
#(define-public FLAT-RAISE    -3/8)
#(define-public FLAT-LOWER    -5/8)
#(define-public SEVEN-E-FLAT  -7/8)

% Set pitch names
arrowedPitchNames =  #`(
	(cff 	. ,(ly:make-pitch -1 0 DOUBLE-FLAT))
	(ctqfl 	. ,(ly:make-pitch -1 0 SEVEN-E-FLAT))
	(ctqf 	. ,(ly:make-pitch -1 0 THREE-Q-FLAT))
	(cfl 	. ,(ly:make-pitch -1 0 FLAT-LOWER))
	(cf   	. ,(ly:make-pitch -1 0 FLAT))
	(cfr 	. ,(ly:make-pitch -1 0 FLAT-RAISE))
	(cqf   	. ,(ly:make-pitch -1 0 SEMI-FLAT))
	(cl   	. ,(ly:make-pitch -1 0 NATURAL-LOWER))
	(c     	. ,(ly:make-pitch -1 0 NATURAL))
	(cr   	. ,(ly:make-pitch -1 0 NATURAL-RAISE))
	(cqs   	. ,(ly:make-pitch -1 0 SEMI-SHARP))
	(csl 	. ,(ly:make-pitch -1 0 SHARP-LOWER))
	(cs   	. ,(ly:make-pitch -1 0 SHARP))
	(csr 	. ,(ly:make-pitch -1 0 SHARP-RAISE))
	(ctqs 	. ,(ly:make-pitch -1 0 THREE-Q-SHARP))
	(ctqsr 	. ,(ly:make-pitch -1 0 SEVEN-E-SHARP))
	(css 	. ,(ly:make-pitch -1 0 DOUBLE-SHARP))

	(dff 	. ,(ly:make-pitch -1 1 DOUBLE-FLAT))
	(dtqfl 	. ,(ly:make-pitch -1 1 SEVEN-E-FLAT))
	(dtqf 	. ,(ly:make-pitch -1 1 THREE-Q-FLAT))
	(dfl 	. ,(ly:make-pitch -1 1 FLAT-LOWER))
	(df   	. ,(ly:make-pitch -1 1 FLAT))
	(dfr 	. ,(ly:make-pitch -1 1 FLAT-RAISE))
	(dqf   	. ,(ly:make-pitch -1 1 SEMI-FLAT))
	(dl   	. ,(ly:make-pitch -1 1 NATURAL-LOWER))
	(d     	. ,(ly:make-pitch -1 1 NATURAL))
	(dr   	. ,(ly:make-pitch -1 1 NATURAL-RAISE))
	(dqs   	. ,(ly:make-pitch -1 1 SEMI-SHARP))
	(dsl 	. ,(ly:make-pitch -1 1 SHARP-LOWER))
	(ds   	. ,(ly:make-pitch -1 1 SHARP))
	(dsr 	. ,(ly:make-pitch -1 1 SHARP-RAISE))
	(dtqs 	. ,(ly:make-pitch -1 1 THREE-Q-SHARP))
	(dtqsr 	. ,(ly:make-pitch -1 1 SEVEN-E-SHARP))
	(dss 	. ,(ly:make-pitch -1 1 DOUBLE-SHARP))

	(eff 	. ,(ly:make-pitch -1 2 DOUBLE-FLAT))
	(etqfl 	. ,(ly:make-pitch -1 2 SEVEN-E-FLAT))
	(etqf 	. ,(ly:make-pitch -1 2 THREE-Q-FLAT))
	(efl 	. ,(ly:make-pitch -1 2 FLAT-LOWER))
	(ef   	. ,(ly:make-pitch -1 2 FLAT))
	(efr 	. ,(ly:make-pitch -1 2 FLAT-RAISE))
	(eqf   	. ,(ly:make-pitch -1 2 SEMI-FLAT))
	(el   	. ,(ly:make-pitch -1 2 NATURAL-LOWER))
	(e     	. ,(ly:make-pitch -1 2 NATURAL))
	(er   	. ,(ly:make-pitch -1 2 NATURAL-RAISE))
	(eqs   	. ,(ly:make-pitch -1 2 SEMI-SHARP))
	(esl 	. ,(ly:make-pitch -1 2 SHARP-LOWER))
	(es   	. ,(ly:make-pitch -1 2 SHARP))
	(esr 	. ,(ly:make-pitch -1 2 SHARP-RAISE))
	(etqs 	. ,(ly:make-pitch -1 2 THREE-Q-SHARP))
	(etqsr 	. ,(ly:make-pitch -1 2 SEVEN-E-SHARP))
	(ess 	. ,(ly:make-pitch -1 2 DOUBLE-SHARP))

	(fff 	. ,(ly:make-pitch -1 3 DOUBLE-FLAT))
	(ftqfl 	. ,(ly:make-pitch -1 3 SEVEN-E-FLAT))
	(ftqf 	. ,(ly:make-pitch -1 3 THREE-Q-FLAT))
	(ffl 	. ,(ly:make-pitch -1 3 FLAT-LOWER))
	(ff   	. ,(ly:make-pitch -1 3 FLAT))
	(ffr 	. ,(ly:make-pitch -1 3 FLAT-RAISE))
	(fqf   	. ,(ly:make-pitch -1 3 SEMI-FLAT))
	(fl   	. ,(ly:make-pitch -1 3 NATURAL-LOWER))
	(f     	. ,(ly:make-pitch -1 3 NATURAL))
	(fr   	. ,(ly:make-pitch -1 3 NATURAL-RAISE))
	(fqs   	. ,(ly:make-pitch -1 3 SEMI-SHARP))
	(fsl 	. ,(ly:make-pitch -1 3 SHARP-LOWER))
	(fs   	. ,(ly:make-pitch -1 3 SHARP))
	(fsr 	. ,(ly:make-pitch -1 3 SHARP-RAISE))
	(ftqs 	. ,(ly:make-pitch -1 3 THREE-Q-SHARP))
	(ftqsr 	. ,(ly:make-pitch -1 3 SEVEN-E-SHARP))
	(fss 	. ,(ly:make-pitch -1 3 DOUBLE-SHARP))

	(gff 	. ,(ly:make-pitch -1 4 DOUBLE-FLAT))
	(gtqfl 	. ,(ly:make-pitch -1 4 SEVEN-E-FLAT))
	(gtqf 	. ,(ly:make-pitch -1 4 THREE-Q-FLAT))
	(gfl 	. ,(ly:make-pitch -1 4 FLAT-LOWER))
	(gf   	. ,(ly:make-pitch -1 4 FLAT))
	(gfr 	. ,(ly:make-pitch -1 4 FLAT-RAISE))
	(gqf   	. ,(ly:make-pitch -1 4 SEMI-FLAT))
	(gl   	. ,(ly:make-pitch -1 4 NATURAL-LOWER))
	(g     	. ,(ly:make-pitch -1 4 NATURAL))
	(gr   	. ,(ly:make-pitch -1 4 NATURAL-RAISE))
	(gqs   	. ,(ly:make-pitch -1 4 SEMI-SHARP))
	(gsl 	. ,(ly:make-pitch -1 4 SHARP-LOWER))
	(gs   	. ,(ly:make-pitch -1 4 SHARP))
	(gsr 	. ,(ly:make-pitch -1 4 SHARP-RAISE))
	(gtqs 	. ,(ly:make-pitch -1 4 THREE-Q-SHARP))
	(gtqsr 	. ,(ly:make-pitch -1 4 SEVEN-E-SHARP))
	(gss 	. ,(ly:make-pitch -1 4 DOUBLE-SHARP))

	(aff 	. ,(ly:make-pitch -1 5 DOUBLE-FLAT))
	(atqfl 	. ,(ly:make-pitch -1 5 SEVEN-E-FLAT))
	(atqf 	. ,(ly:make-pitch -1 5 THREE-Q-FLAT))
	(afl 	. ,(ly:make-pitch -1 5 FLAT-LOWER))
	(af   	. ,(ly:make-pitch -1 5 FLAT))
	(afr 	. ,(ly:make-pitch -1 5 FLAT-RAISE))
	(aqf   	. ,(ly:make-pitch -1 5 SEMI-FLAT))
	(al   	. ,(ly:make-pitch -1 5 NATURAL-LOWER))
	(a     	. ,(ly:make-pitch -1 5 NATURAL))
	(ar   	. ,(ly:make-pitch -1 5 NATURAL-RAISE))
	(aqs   	. ,(ly:make-pitch -1 5 SEMI-SHARP))
	(asl 	. ,(ly:make-pitch -1 5 SHARP-LOWER))
	(as   	. ,(ly:make-pitch -1 5 SHARP))
	(asr 	. ,(ly:make-pitch -1 5 SHARP-RAISE))
	(atqs 	. ,(ly:make-pitch -1 5 THREE-Q-SHARP))
	(atqsr 	. ,(ly:make-pitch -1 5 SEVEN-E-SHARP))
	(ass 	. ,(ly:make-pitch -1 5 DOUBLE-SHARP))

	(bff 	. ,(ly:make-pitch -1 6 DOUBLE-FLAT))
	(btqfl 	. ,(ly:make-pitch -1 6 SEVEN-E-FLAT))
	(btqf 	. ,(ly:make-pitch -1 6 THREE-Q-FLAT))
	(bfl 	. ,(ly:make-pitch -1 6 FLAT-LOWER))
	(bf   	. ,(ly:make-pitch -1 6 FLAT))
	(bfr 	. ,(ly:make-pitch -1 6 FLAT-RAISE))
	(bqf   	. ,(ly:make-pitch -1 6 SEMI-FLAT))
	(bl   	. ,(ly:make-pitch -1 6 NATURAL-LOWER))
	(b     	. ,(ly:make-pitch -1 6 NATURAL))
	(br   	. ,(ly:make-pitch -1 6 NATURAL-RAISE))
	(bqs   	. ,(ly:make-pitch -1 6 SEMI-SHARP))
	(bsl 	. ,(ly:make-pitch -1 6 SHARP-LOWER))
	(bs   	. ,(ly:make-pitch -1 6 SHARP))
	(bsr 	. ,(ly:make-pitch -1 6 SHARP-RAISE))
	(btqs 	. ,(ly:make-pitch -1 6 THREE-Q-SHARP))
	(btqsr 	. ,(ly:make-pitch -1 6 SEVEN-E-SHARP))
	(bss 	. ,(ly:make-pitch -1 6 DOUBLE-SHARP))
)

pitchnames = \arrowedPitchNames
#(ly:parser-set-note-names pitchnames)

arrowGlyphs = #`(
	( 1                     . "accidentals.doublesharp")
	(,SEVEN-E-SHARP         . "accidentals.sharp.slashslashslash.stemstem")
	( 3/4                   . "accidentals.sharp.slashslash.stemstemstem")
	(,SHARP-RAISE           . "accidentals.sharp.arrowup")
	( 1/2                   . "accidentals.sharp")
	(,SHARP-LOWER           . "accidentals.sharp.arrowdown")
	( 1/4                   . "accidentals.sharp.slashslash.stem")
	(,NATURAL-RAISE        	. "accidentals.natural.arrowup")
	( 0                     . "accidentals.natural")
	(,NATURAL-LOWER         . "accidentals.natural.arrowdown")
	(-1/4                   . "accidentals.mirroredflat")
	(,FLAT-RAISE            . "accidentals.flat.arrowup")
	(-1/2                   . "accidentals.flat")
	(,FLAT-LOWER            . "accidentals.flat.arrowdown")
	(-3/4                   . "accidentals.mirroredflat.flat")
	(,SEVEN-E-FLAT          . "accidentals.flatflat.slash")
	(-1                     . "accidentals.flatflat")
)

\layout {
  \context {
    \Score
    \override KeySignature.glyph-name-alist = \arrowGlyphs
    \override Accidental.glyph-name-alist = \arrowGlyphs
    \override AccidentalCautionary.glyph-name-alist = \arrowGlyphs
    \override TrillPitchAccidental.glyph-name-alist = \arrowGlyphs
    \override AmbitusAccidental.glyph-name-alist = \arrowGlyphs
  }
  \context {
    \Staff
    extraNatural = ##f % this is a workaround for bug #1701
  }
}
